﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Telerik.Web.UI;

public partial class _Default : System.Web.UI.Page
{
    RadGrid grid;
    protected void Page_Init(object sender, EventArgs e)
    {
        grid = new RadGrid() { ID = "RadGrid1" };
        grid.AutoGenerateColumns = false;
        grid.AllowPaging = true;
        grid.AllowFilteringByColumn = true;
        grid.NeedDataSource += (obj, args) => ((RadGrid)obj).DataSource = Enumerable.Range(0, 30).Select(i => new { ID = i, Amount = i + i * 50 });

        GridBoundColumn column = new GridBoundColumn() { DataField = "ID", HeaderText = "ID", AllowFiltering = true };
        grid.MasterTableView.Columns.Add(column);

        column = new GridBoundColumn() { DataField = "Amount", HeaderText = "Amount", AllowFiltering = true };
        column.FilterTemplate = new CustomFilter();
        grid.MasterTableView.Columns.Add(column);

        holder1.Controls.Add(grid);
    }

    protected override void OnPreRender(EventArgs e)
    {
        base.OnPreRender(e);

        if (grid != null)
        {
            GridFilteringItem filterItem = grid.MasterTableView.GetItems(GridItemType.FilteringItem)[0] as GridFilteringItem;

            if (filterItem != null)
            {

                foreach (GridColumn column in grid.MasterTableView.Columns)
                {
                    if (column.FilterTemplate != null)
                    {
                        RadComboBox combo = filterItem[column.UniqueName].FindControl("box1") as RadComboBox;

                        if (combo != null)
                        {
                            RadAjaxManager1.Alert("Combo found!");
                        }

                        //NB: Besides, filterItem[column.UniqueName].Controls will give you access to all the controls rendered by the filter template of the column
                    }
                }


            }
        }

    }

}

public class CustomFilter : ITemplate
{
    

    public void InstantiateIn(Control container)
    {
        RadComboBox box = new RadComboBox() { ID = "box1" };

        container.Controls.Add(box);
    }

    
}
